//+------------------------------------------------------------------+
//|                                        Trend Detection Index.mq4 |
//|                                                           mladen |
//|                                                                  |
//| Trend Detection Index originaly developed by M.H. Pee            |
//| TASC : 19:10 (October 2001) article                              |
//| "Are You In A Trend? Trend Detection Index"                      |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    2
#property indicator_color1     LimeGreen
#property indicator_color2     DarkOrange
#property indicator_level1     0
#property indicator_levelcolor DimGray

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT;
extern int             Length    = 20;
extern int             Price     = PRICE_CLOSE;

//
//
//
//
//

double Td[];
double Tdi[];
double values[][4];

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,Td);  SetIndexLabel(0,"TD");
   SetIndexBuffer(1,Tdi); SetIndexLabel(1,"TDI");
   
      //
      //
      //
      //
      //
      
         TimeFrame = MathMax(TimeFrame,_Period);
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
   IndicatorShortName(timeFrameToString(TimeFrame)+" Trend Detection Index");
return(0);
}
int deinit() {  return(0);}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define mom      0
#define abs      1
#define sum_abs  2
#define sum_abs2 3

//
//
//
//
//

int start()
{
   int i,j,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-Length*2);
         if (returnBars) { Td[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame == Period() || TimeFrame == PERIOD_CURRENT)
   {
     if (ArrayRange(values,0) != Bars) ArrayResize(values,Bars);
     for (i=limit, r=Bars-limit-1; i>=0; i--,r++)
     {
         values[r][mom]      = iMA(NULL,0,1,0,MODE_SMA,Price,i)-iMA(NULL,0,1,0,MODE_SMA,Price,i+Length);
         values[r][abs]      = MathAbs(values[r][mom]);
         values[r][sum_abs]  = 0;
         values[r][sum_abs2] = 0;
         Td[i]               = 0;

         //
         //
         //
         //
         //

         for (j=0;j<Length;j++)
         {
            Td[i]               += values[r-j][mom];
            values[r][sum_abs]  += values[r-j][abs];
            values[r][sum_abs2] += values[r-j][abs];
         }                  
         for (;j<Length*2;j++) values[r][sum_abs2] += values[r-j][abs];

         //
         //
         //
         //
         //
      
         Tdi[i] = MathAbs(Td[i])+values[r][sum_abs]-values[r][sum_abs2];
     }
   return(0);
   }
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         Td[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Price,0,y);
         Tdi[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Price,1,y);
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}